import java.sql.*;
/***************************************************************************/
/*    Uebung 18                                                            */
/*                                                                         */
/*    Beispielanwendung fr SQL-Zugriffe in java                           */
/*                                                                         */
/*    Version 3  fr eclipse_jdk                                           */
/*                                                                         */
/***************************************************************************/

public class uebung19 {

   public static void main(String[] args)
   {
      Connection conn         = null;
      Statement stmt          = null;
      PreparedStatement pstmt = null;
      DatabaseMetaData dict   = null;
      String treibername      = null;
      String db_name          = null;
      String db_version       = null;
      
      int anz = 0;
         
      try
      {
         if (args.length != 1 || args[0].equalsIgnoreCase("oracle"))
         {
            DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
            conn = DriverManager.getConnection 
                   ("jdbc:oracle:thin:@gw3svr32.gw.net.fh-jena.de:1521:oracle11", "ss12etxyz", "geheim");
            System.out.println("Verbindung zur Oracle Datenbank 11g hergestellt !");
         }
         else if (args[0].equalsIgnoreCase("mysql"))
         {
             DriverManager.registerDriver(new org.gjt.mm.mysql.Driver());
             conn = DriverManager.getConnection 
                     ("jdbc:mysql://gw3svr32.gw.net.fh-jena.de:3306/ss12etxyz","ss12etxyz","geheim");
             System.out.println("Verbindung zur MySQL Datenbank 5.1 hergestellt !");
         }
         else
         {
            System.out.println("Ungueltiger Programm-Aufruf !");
            return;
         }    
        
         dict        = conn.getMetaData();
         treibername = dict.getDriverName();
         db_name     = dict.getDatabaseProductName();
         db_version  = dict.getDatabaseProductVersion();
     
         System.out.println("Treiber:    " + treibername);
         System.out.println("DB_Name:    " + db_name);
         System.out.println("DB_Version: " + db_version);
         System.out.println("  ");
     
         stmt = conn.createStatement();
         anz = stmt.executeUpdate("insert into Lieferant select LNR+1,name,ort,status from Lieferant where LNR=1");
         System.out.println(anz + " Lieferant neu angelegt !");
         
         anz = stmt.executeUpdate("insert into liefert select LNR+1,ANR,Mindestmenge,lieferzeit,Preis from liefert where LNR=1");
         System.out.println(anz + " Lieferbedingungen neu angelegt !");
         
         pstmt = conn.prepareStatement("UPDATE liefert SET Preis = Preis * ? WHERE LNR = ?");
         pstmt.setFloat(1,1.1f);
         pstmt.setInt(2, 2);
      
         anz = pstmt.executeUpdate();
            
         System.out.println(anz + " Lieferbedingungen geaendert !");
         System.out.println("  ");   
      
         pstmt = conn.prepareStatement("select LNR as LIEF_NR, ANR, Preis from liefert where LNR = ?");
         pstmt.setInt(1,2);
               
         ResultSet rs = pstmt.executeQuery();
          
         ResultSetMetaData data = rs.getMetaData();
         System.out.println("getTableName: " + data.getTableName(1));
         System.out.println("getColumnCount: " + data.getColumnCount());
         System.out.println("Werte fuer die erste Spalte: ");
         System.out.println("getColumnName: " + data.getColumnName(1));
         System.out.println("getColumnTypeName: " + data.getColumnTypeName(1));
         System.out.println("Werte fuer die zweite Spalte: ");
         System.out.println("getColumnName: " + data.getColumnName(2));
         System.out.println("getColumnTypeName: " + data.getColumnTypeName(2));
         System.out.println("Werte fuer die dritte Spalte: ");
         System.out.println("getColumnName: " + data.getColumnName(3));
         System.out.println("getColumnTypeName: " + data.getColumnTypeName(3));

         while (rs.next())
         {
            System.out.println(rs.getInt(1) + ";" + rs.getString(2)+ ";" + rs.getInt(3));
         }
           
         System.out.println("  ");
         anz = stmt.executeUpdate("delete from liefert where LNR=2");

         System.out.println(anz + " Lieferbedingungen geloescht !");

         anz = stmt.executeUpdate("delete from Lieferant where LNR=2");
         System.out.println(anz + " Lieferant geloescht !");
            
         pstmt.close();
         conn.close();
          
         if (args.length != 1 || args[0].equalsIgnoreCase("oracle"))
            System.out.println("Verbindung zur Oracle Datenbank 11g beendet !");
         else
            System.out.println("Verbindung zur MySQL Datenbank 5.1 beendet !");        
      }
      catch (SQLException e)
      {
          System.out.println(e);
      }

      try
      {
         pstmt.close();
         conn.close();
      }
      catch (SQLException e)
      {
         System.out.println(e);
         return;
      }

   }
}
